diff -r fb51f5b4aa4c trytond/tests/test_fields.py
--- a/trytond/tests/test_fields.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/tests/test_fields.py	Mon Sep 24 20:36:36 2012 +0200
@@ -99,6 +99,8 @@
         self.reference_required = POOL.get('test.reference_required')
 
         self.property_ = POOL.get('test.property')
+        self.ir_property = POOL.get('ir.property')
+        self.model_field = POOL.get('ir.model.field')
 
     def test0010boolean(self):
         '''
@@ -106,107 +108,97 @@
         '''
         with Transaction().start(DB_NAME, USER,
                 context=CONTEXT) as transaction:
-            boolean1_id = self.boolean.create({
-                'boolean': True,
-                })
-            self.assert_(boolean1_id)
-
-            boolean1 = self.boolean.read(boolean1_id, ['boolean'])
-            self.assert_(boolean1['boolean'] == True)
-
-            boolean_ids = self.boolean.search([
-                ('boolean', '=', True),
-                ])
-            self.assert_(boolean_ids == [boolean1_id])
-
-            boolean_ids = self.boolean.search([
-                ('boolean', '!=', True),
-                ])
-            self.assert_(boolean_ids == [])
-
-            boolean_ids = self.boolean.search([
-                ('boolean', 'in', [True]),
-                ])
-            self.assert_(boolean_ids == [boolean1_id])
-
-            boolean_ids = self.boolean.search([
-                ('boolean', 'in', [False]),
-                ])
-            self.assert_(boolean_ids == [])
-
-            boolean_ids = self.boolean.search([
-                ('boolean', 'not in', [True]),
-                ])
-            self.assert_(boolean_ids == [])
-
-            boolean_ids = self.boolean.search([
-                ('boolean', 'not in', [False]),
-                ])
-            self.assert_(boolean_ids == [boolean1_id])
-
-            boolean2_id = self.boolean.create({
-                'boolean': False,
-                })
-            self.assert_(boolean2_id)
-
-            boolean2 = self.boolean.read(boolean2_id, ['boolean'])
-            self.assert_(boolean2['boolean'] == False)
-
-            boolean_ids = self.boolean.search([
-                ('boolean', '=', False),
-                ])
-            self.assert_(boolean_ids == [boolean2_id])
-
-            boolean_ids = self.boolean.search([
-                ('boolean', 'in', [True, False]),
-                ])
-            self.assert_(boolean_ids == [boolean1_id, boolean2_id])
-
-            boolean_ids = self.boolean.search([
-                ('boolean', 'not in', [True, False]),
-                ])
-            self.assert_(boolean_ids == [])
-
-            boolean3_id = self.boolean.create({})
-            self.assert_(boolean3_id)
+            boolean1 = self.boolean.create({
+                    'boolean': True,
+                    })
+            self.assert_(boolean1)
+            self.assertEqual(boolean1.boolean, True)
+
+            booleans = self.boolean.search([
+                    ('boolean', '=', True),
+                    ])
+            self.assertEqual(booleans, [boolean1])
+
+            booleans = self.boolean.search([
+                    ('boolean', '!=', True),
+                    ])
+            self.assertEqual(booleans, [])
+
+            booleans = self.boolean.search([
+                    ('boolean', 'in', [True]),
+                    ])
+            self.assertEqual(booleans, [boolean1])
+
+            booleans = self.boolean.search([
+                    ('boolean', 'in', [False]),
+                    ])
+            self.assertEqual(booleans, [])
+
+            booleans = self.boolean.search([
+                    ('boolean', 'not in', [True]),
+                    ])
+            self.assertEqual(booleans, [])
+
+            booleans = self.boolean.search([
+                    ('boolean', 'not in', [False]),
+                    ])
+            self.assertEqual(booleans, [boolean1])
+
+            boolean2 = self.boolean.create({
+                    'boolean': False,
+                    })
+            self.assert_(boolean2)
+            self.assertEqual(boolean2.boolean, False)
+
+            booleans = self.boolean.search([
+                    ('boolean', '=', False),
+                    ])
+            self.assertEqual(booleans, [boolean2])
+
+            booleans = self.boolean.search([
+                    ('boolean', 'in', [True, False]),
+                    ])
+            self.assertEqual(booleans, [boolean1, boolean2])
+
+            booleans = self.boolean.search([
+                    ('boolean', 'not in', [True, False]),
+                    ])
+            self.assertEqual(booleans, [])
+
+            boolean3 = self.boolean.create({})
+            self.assert_(boolean3)
+            self.assertEqual(boolean3.boolean, False)
 
             # Test search with NULL value
-            boolean4_id = self.boolean.create({
+            boolean4 = self.boolean.create({
                     'boolean': None,
                     })
-            self.assert_(boolean4_id)
-
-            boolean_ids = self.boolean.search([
+            self.assert_(boolean4)
+
+            booleans = self.boolean.search([
                     ('boolean', '=', False),
                     ])
-            self.assertEqual(boolean_ids,
-                [boolean2_id, boolean3_id, boolean4_id])
-
-            boolean_ids = self.boolean.search([
+            self.assertEqual(booleans,
+                [boolean2, boolean3, boolean4])
+
+            booleans = self.boolean.search([
                     ('boolean', '!=', False),
                     ])
-            self.assertEqual(boolean_ids, [boolean1_id])
-
-            boolean3 = self.boolean.read(boolean3_id, ['boolean'])
-            self.assert_(boolean3['boolean'] == False)
-
-            boolean4_id = self.boolean_default.create({})
-            self.assert_(boolean4_id)
-
-            boolean4 = self.boolean_default.read(boolean4_id, ['boolean'])
-            self.assert_(boolean4['boolean'] == True)
-
-            self.boolean.write(boolean1_id, {
-                'boolean': False,
-                })
-            boolean1 = self.boolean.read(boolean1_id, ['boolean'])
-            self.assert_(boolean1['boolean'] == False)
-
-            self.boolean.write(boolean2_id, {
-                'boolean': True,
-                })
-            boolean2 = self.boolean.read(boolean2_id, ['boolean'])
-            self.assert_(boolean2['boolean'] == True)
+            self.assertEqual(booleans, [boolean1])
+
+            boolean4 = self.boolean_default.create({})
+            self.assert_(boolean4)
+            self.assert_(boolean4.boolean == True)
+
+            self.boolean.write([boolean1], {
+                    'boolean': False,
+                    })
+            self.assertEqual(boolean1.boolean, False)
+
+            self.boolean.write([boolean2], {
+                    'boolean': True,
+                    })
+            self.assertEqual(boolean2.boolean, True)
 
             transaction.cursor.rollback()
 
@@ -216,191 +208,179 @@
         '''
         with Transaction().start(DB_NAME, USER,
                 context=CONTEXT) as transaction:
-            integer1_id = self.integer.create({
-                'integer': 1,
-                })
-            self.assert_(integer1_id)
-
-            integer1 = self.integer.read(integer1_id, ['integer'])
-            self.assert_(integer1['integer'] == 1)
-
-            integer_ids = self.integer.search([
-                ('integer', '=', 1),
-                ])
-            self.assert_(integer_ids == [integer1_id])
-
-            integer_ids = self.integer.search([
-                ('integer', '=', 0),
-                ])
-            self.assert_(integer_ids == [])
-
-            integer_ids = self.integer.search([
-                ('integer', '!=', 1),
-                ])
-            self.assert_(integer_ids == [])
-
-            integer_ids = self.integer.search([
-                ('integer', '!=', 0),
-                ])
-            self.assert_(integer_ids == [integer1_id])
-
-            integer_ids = self.integer.search([
-                ('integer', 'in', [1]),
-                ])
-            self.assert_(integer_ids == [integer1_id])
-
-            integer_ids = self.integer.search([
-                ('integer', 'in', [0]),
-                ])
-            self.assert_(integer_ids == [])
-
-            integer_ids = self.integer.search([
-                ('integer', 'in', []),
-                ])
-            self.assert_(integer_ids == [])
-
-            integer_ids = self.integer.search([
-                ('integer', 'not in', [1]),
-                ])
-            self.assert_(integer_ids == [])
-
-            integer_ids = self.integer.search([
-                ('integer', 'not in', [0]),
-                ])
-            self.assert_(integer_ids == [integer1_id])
-
-            integer_ids = self.integer.search([
-                ('integer', 'not in', []),
-                ])
-            self.assert_(integer_ids == [integer1_id])
-
-            integer_ids = self.integer.search([
-                ('integer', '<', 5),
-                ])
-            self.assert_(integer_ids == [integer1_id])
-
-            integer_ids = self.integer.search([
-                ('integer', '<', -5),
-                ])
-            self.assert_(integer_ids == [])
-
-            integer_ids = self.integer.search([
-                ('integer', '<', 1),
-                ])
-            self.assert_(integer_ids == [])
-
-            integer_ids = self.integer.search([
-                ('integer', '<=', 5),
-                ])
-            self.assert_(integer_ids == [integer1_id])
-
-            integer_ids = self.integer.search([
-                ('integer', '<=', -5),
-                ])
-            self.assert_(integer_ids == [])
-
-            integer_ids = self.integer.search([
-                ('integer', '<=', 1),
-                ])
-            self.assert_(integer_ids == [integer1_id])
-
-            integer_ids = self.integer.search([
-                ('integer', '>', 5),
-                ])
-            self.assert_(integer_ids == [])
-
-            integer_ids = self.integer.search([
-                ('integer', '>', -5),
-                ])
-            self.assert_(integer_ids == [integer1_id])
-
-            integer_ids = self.integer.search([
-                ('integer', '>', 1),
-                ])
-            self.assert_(integer_ids == [])
-
-            integer_ids = self.integer.search([
-                ('integer', '>=', 5),
-                ])
-            self.assert_(integer_ids == [])
-
-            integer_ids = self.integer.search([
-                ('integer', '>=', -5),
-                ])
-            self.assert_(integer_ids == [integer1_id])
-
-            integer_ids = self.integer.search([
-                ('integer', '>=', 1),
-                ])
-            self.assert_(integer_ids == [integer1_id])
-
-            integer2_id = self.integer.create({
-                'integer': 0,
-                })
-            self.assert_(integer2_id)
-
-            integer2 = self.integer.read(integer2_id, ['integer'])
-            self.assert_(integer2['integer'] == 0)
-
-            integer_ids = self.integer.search([
-                ('integer', '=', 0),
-                ])
-            self.assert_(integer_ids == [integer2_id])
-
-            integer_ids = self.integer.search([
-                ('integer', 'in', [0, 1]),
-                ])
-            self.assert_(integer_ids == [integer1_id, integer2_id])
-
-            integer_ids = self.integer.search([
-                ('integer', 'not in', [0, 1]),
-                ])
-            self.assert_(integer_ids == [])
-
-            integer3_id = self.integer.create({})
-            self.assert_(integer3_id)
-
-            integer3 = self.integer.read(integer3_id, ['integer'])
-            self.assert_(integer3['integer'] is None)
-
-            integer4_id = self.integer_default.create({})
-            self.assert_(integer4_id)
-
-            integer4 = self.integer_default.read(integer4_id, ['integer'])
-            self.assert_(integer4['integer'] == 5)
-
-            self.integer.write(integer1_id, {
-                'integer': 0,
-                })
-            integer1 = self.integer.read(integer1_id, ['integer'])
-            self.assert_(integer1['integer'] == 0)
-
-            self.integer.write(integer2_id, {
-                'integer': 1,
-                })
-            integer2 = self.integer.read(integer2_id, ['integer'])
-            self.assert_(integer2['integer'] == 1)
-
-            self.failUnlessRaises(Exception, self.integer.create, {
-                'integer': 'test',
-                })
-
-            self.failUnlessRaises(Exception, self.integer.write, integer1_id, {
-                'integer': 'test',
-                })
+            integer1 = self.integer.create({
+                    'integer': 1,
+                    })
+            self.assert_(integer1)
+            self.assertEqual(integer1.integer, 1)
+
+            integers = self.integer.search([
+                    ('integer', '=', 1),
+                    ])
+            self.assertEqual(integers, [integer1])
+
+            integers = self.integer.search([
+                    ('integer', '=', 0),
+                    ])
+            self.assertEqual(integers, [])
+
+            integers = self.integer.search([
+                    ('integer', '!=', 1),
+                    ])
+            self.assertEqual(integers, [])
+
+            integers = self.integer.search([
+                    ('integer', '!=', 0),
+                    ])
+            self.assertEqual(integers, [integer1])
+
+            integers = self.integer.search([
+                    ('integer', 'in', [1]),
+                    ])
+            self.assertEqual(integers, [integer1])
+
+            integers = self.integer.search([
+                    ('integer', 'in', [0]),
+                    ])
+            self.assertEqual(integers, [])
+
+            integers = self.integer.search([
+                    ('integer', 'in', []),
+                    ])
+            self.assertEqual(integers, [])
+
+            integers = self.integer.search([
+                    ('integer', 'not in', [1]),
+                    ])
+            self.assertEqual(integers, [])
+
+            integers = self.integer.search([
+                    ('integer', 'not in', [0]),
+                    ])
+            self.assertEqual(integers, [integer1])
+
+            integers = self.integer.search([
+                    ('integer', 'not in', []),
+                    ])
+            self.assertEqual(integers, [integer1])
+
+            integers = self.integer.search([
+                    ('integer', '<', 5),
+                    ])
+            self.assertEqual(integers, [integer1])
+
+            integers = self.integer.search([
+                    ('integer', '<', -5),
+                    ])
+            self.assertEqual(integers, [])
+
+            integers = self.integer.search([
+                    ('integer', '<', 1),
+                    ])
+            self.assertEqual(integers, [])
+
+            integers = self.integer.search([
+                    ('integer', '<=', 5),
+                    ])
+            self.assertEqual(integers, [integer1])
+
+            integers = self.integer.search([
+                    ('integer', '<=', -5),
+                    ])
+            self.assertEqual(integers, [])
+
+            integers = self.integer.search([
+                    ('integer', '<=', 1),
+                    ])
+            self.assertEqual(integers, [integer1])
+
+            integers = self.integer.search([
+                    ('integer', '>', 5),
+                    ])
+            self.assertEqual(integers, [])
+
+            integers = self.integer.search([
+                    ('integer', '>', -5),
+                    ])
+            self.assertEqual(integers, [integer1])
+
+            integers = self.integer.search([
+                    ('integer', '>', 1),
+                    ])
+            self.assertEqual(integers, [])
+
+            integers = self.integer.search([
+                    ('integer', '>=', 5),
+                    ])
+            self.assertEqual(integers, [])
+
+            integers = self.integer.search([
+                    ('integer', '>=', -5),
+                    ])
+            self.assertEqual(integers, [integer1])
+
+            integers = self.integer.search([
+                    ('integer', '>=', 1),
+                    ])
+            self.assertEqual(integers, [integer1])
+
+            integer2 = self.integer.create({
+                    'integer': 0,
+                    })
+            self.assert_(integer2)
+            self.assertEqual(integer2.integer, 0)
+
+            integers = self.integer.search([
+                    ('integer', '=', 0),
+                    ])
+            self.assertEqual(integers, [integer2])
+
+            integers = self.integer.search([
+                    ('integer', 'in', [0, 1]),
+                    ])
+            self.assertEqual(integers, [integer1, integer2])
+
+            integers = self.integer.search([
+                    ('integer', 'not in', [0, 1]),
+                    ])
+            self.assertEqual(integers, [])
+
+            integer3 = self.integer.create({})
+            self.assert_(integer3)
+            self.assertEqual(integer3.integer, None)
+
+            integer4 = self.integer_default.create({})
+            self.assert_(integer4)
+            self.assertEqual(integer4.integer, 5)
+
+            self.integer.write([integer1], {
+                    'integer': 0,
+                    })
+            self.assertEqual(integer1.integer, 0)
+
+            self.integer.write([integer2], {
+                    'integer': 1,
+                    })
+            self.assertEqual(integer2.integer, 1)
+
+            self.assertRaises(Exception, self.integer.create, {
+                    'integer': 'test',
+                    })
+
+            self.assertRaises(Exception, self.integer.write, [integer1], {
+                    'integer': 'test',
+                    })
 
             # We should catch UserError but mysql does not raise an
             # IntegrityError but an OperationalError
             self.assertRaises(Exception, self.integer_required.create, {})
             transaction.cursor.rollback()
 
-            integer5_id = self.integer_required.create({
+            integer5 = self.integer_required.create({
                     'integer': 0,
                     })
-            self.assert_(integer5_id)
-
-            integer5 = self.integer_required.read(integer5_id, ['integer'])
-            self.assert_(integer5['integer'] == 0)
+            self.assert_(integer5)
+            self.assertEqual(integer5.integer, 0)
 
             transaction.cursor.rollback()
 
@@ -410,215 +390,202 @@
         '''
         with Transaction().start(DB_NAME, USER,
                 context=CONTEXT) as transaction:
-            float1_id = self.float.create({
-                'float': 1.1,
-                })
-            self.assert_(float1_id)
-
-            float1 = self.float.read(float1_id, ['float'])
-            self.assert_(float1['float'] == 1.1)
-
-            float_ids = self.float.search([
-                ('float', '=', 1.1),
-                ])
-            self.assert_(float_ids == [float1_id])
-
-            float_ids = self.float.search([
-                ('float', '=', 0),
-                ])
-            self.assert_(float_ids == [])
-
-            float_ids = self.float.search([
-                ('float', '!=', 1.1),
-                ])
-            self.assert_(float_ids == [])
-
-            float_ids = self.float.search([
-                ('float', '!=', 0),
-                ])
-            self.assert_(float_ids == [float1_id])
-
-            float_ids = self.float.search([
-                ('float', 'in', [1.1]),
-                ])
-            self.assert_(float_ids == [float1_id])
-
-            float_ids = self.float.search([
-                ('float', 'in', [0]),
-                ])
-            self.assert_(float_ids == [])
-
-            float_ids = self.float.search([
-                ('float', 'in', []),
-                ])
-            self.assert_(float_ids == [])
-
-            float_ids = self.float.search([
-                ('float', 'not in', [1.1]),
-                ])
-            self.assert_(float_ids == [])
-
-            float_ids = self.float.search([
-                ('float', 'not in', [0]),
-                ])
-            self.assert_(float_ids == [float1_id])
-
-            float_ids = self.float.search([
-                ('float', 'not in', []),
-                ])
-            self.assert_(float_ids == [float1_id])
-
-            float_ids = self.float.search([
-                ('float', '<', 5),
-                ])
-            self.assert_(float_ids == [float1_id])
-
-            float_ids = self.float.search([
-                ('float', '<', -5),
-                ])
-            self.assert_(float_ids == [])
-
-            float_ids = self.float.search([
-                ('float', '<', 1.1),
-                ])
-            self.assert_(float_ids == [])
-
-            float_ids = self.float.search([
-                ('float', '<=', 5),
-                ])
-            self.assert_(float_ids == [float1_id])
-
-            float_ids = self.float.search([
-                ('float', '<=', -5),
-                ])
-            self.assert_(float_ids == [])
-
-            float_ids = self.float.search([
-                ('float', '<=', 1.1),
-                ])
-            self.assert_(float_ids == [float1_id])
-
-            float_ids = self.float.search([
-                ('float', '>', 5),
-                ])
-            self.assert_(float_ids == [])
-
-            float_ids = self.float.search([
-                ('float', '>', -5),
-                ])
-            self.assert_(float_ids == [float1_id])
-
-            float_ids = self.float.search([
-                ('float', '>', 1.1),
-                ])
-            self.assert_(float_ids == [])
-
-            float_ids = self.float.search([
-                ('float', '>=', 5),
-                ])
-            self.assert_(float_ids == [])
-
-            float_ids = self.float.search([
-                ('float', '>=', -5),
-                ])
-            self.assert_(float_ids == [float1_id])
-
-            float_ids = self.float.search([
-                ('float', '>=', 1.1),
-                ])
-            self.assert_(float_ids == [float1_id])
-
-            float2_id = self.float.create({
-                'float': 0,
-                })
-            self.assert_(float2_id)
-
-            float2 = self.float.read(float2_id, ['float'])
-            self.assert_(float2['float'] == 0)
-
-            float_ids = self.float.search([
-                ('float', '=', 0),
-                ])
-            self.assert_(float_ids == [float2_id])
-
-            float_ids = self.float.search([
-                ('float', 'in', [0, 1.1]),
-                ])
-            self.assert_(float_ids == [float1_id, float2_id])
-
-            float_ids = self.float.search([
-                ('float', 'not in', [0, 1.1]),
-                ])
-            self.assert_(float_ids == [])
-
-            float3_id = self.float.create({})
-            self.assert_(float3_id)
-
-            float3 = self.float.read(float3_id, ['float'])
-            self.assert_(float3['float'] is None)
-
-            float4_id = self.float_default.create({})
-            self.assert_(float4_id)
-
-            float4 = self.float_default.read(float4_id, ['float'])
-            self.assert_(float4['float'] == 5.5)
-
-            self.float.write(float1_id, {
-                'float': 0,
-                })
-            float1 = self.float.read(float1_id, ['float'])
-            self.assert_(float1['float'] == 0)
-
-            self.float.write(float2_id, {
-                'float': 1.1,
-                })
-            float2 = self.float.read(float2_id, ['float'])
-            self.assert_(float2['float'] == 1.1)
-
-            self.failUnlessRaises(Exception, self.float.create, {
-                'float': 'test',
-                })
-
-            self.failUnlessRaises(Exception, self.float.write, float1_id, {
-                'float': 'test',
-                })
+            float1 = self.float.create({
+                    'float': 1.1,
+                    })
+            self.assert_(float1)
+            self.assertEqual(float1.float, 1.1)
+
+            floats = self.float.search([
+                    ('float', '=', 1.1),
+                    ])
+            self.assertEqual(floats, [float1])
+
+            floats = self.float.search([
+                    ('float', '=', 0),
+                    ])
+            self.assertEqual(floats, [])
+
+            floats = self.float.search([
+                    ('float', '!=', 1.1),
+                    ])
+            self.assertEqual(floats, [])
+
+            floats = self.float.search([
+                    ('float', '!=', 0),
+                    ])
+            self.assertEqual(floats, [float1])
+
+            floats = self.float.search([
+                    ('float', 'in', [1.1]),
+                    ])
+            self.assertEqual(floats, [float1])
+
+            floats = self.float.search([
+                    ('float', 'in', [0]),
+                    ])
+            self.assertEqual(floats, [])
+
+            floats = self.float.search([
+                    ('float', 'in', []),
+                    ])
+            self.assertEqual(floats, [])
+
+            floats = self.float.search([
+                    ('float', 'not in', [1.1]),
+                    ])
+            self.assertEqual(floats, [])
+
+            floats = self.float.search([
+                    ('float', 'not in', [0]),
+                    ])
+            self.assertEqual(floats, [float1])
+
+            floats = self.float.search([
+                    ('float', 'not in', []),
+                    ])
+            self.assertEqual(floats, [float1])
+
+            floats = self.float.search([
+                    ('float', '<', 5),
+                    ])
+            self.assertEqual(floats, [float1])
+
+            floats = self.float.search([
+                    ('float', '<', -5),
+                    ])
+            self.assertEqual(floats, [])
+
+            floats = self.float.search([
+                    ('float', '<', 1.1),
+                    ])
+            self.assertEqual(floats, [])
+
+            floats = self.float.search([
+                    ('float', '<=', 5),
+                    ])
+            self.assertEqual(floats, [float1])
+
+            floats = self.float.search([
+                    ('float', '<=', -5),
+                    ])
+            self.assertEqual(floats, [])
+
+            floats = self.float.search([
+                    ('float', '<=', 1.1),
+                    ])
+            self.assertEqual(floats, [float1])
+
+            floats = self.float.search([
+                    ('float', '>', 5),
+                    ])
+            self.assertEqual(floats, [])
+
+            floats = self.float.search([
+                    ('float', '>', -5),
+                    ])
+            self.assertEqual(floats, [float1])
+
+            floats = self.float.search([
+                    ('float', '>', 1.1),
+                    ])
+            self.assertEqual(floats, [])
+
+            floats = self.float.search([
+                    ('float', '>=', 5),
+                    ])
+            self.assertEqual(floats, [])
+
+            floats = self.float.search([
+                    ('float', '>=', -5),
+                    ])
+            self.assertEqual(floats, [float1])
+
+            floats = self.float.search([
+                    ('float', '>=', 1.1),
+                    ])
+            self.assertEqual(floats, [float1])
+
+            float2 = self.float.create({
+                    'float': 0,
+                    })
+            self.assert_(float2)
+            self.assertEqual(float2.float, 0)
+
+            floats = self.float.search([
+                    ('float', '=', 0),
+                    ])
+            self.assertEqual(floats, [float2])
+
+            floats = self.float.search([
+                    ('float', 'in', [0, 1.1]),
+                    ])
+            self.assertEqual(floats, [float1, float2])
+
+            floats = self.float.search([
+                    ('float', 'not in', [0, 1.1]),
+                    ])
+            self.assertEqual(floats, [])
+
+            float3 = self.float.create({})
+            self.assert_(float3)
+            self.assertEqual(float3.float, None)
+
+            float4 = self.float_default.create({})
+            self.assert_(float4)
+            self.assertEqual(float4.float, 5.5)
+
+            self.float.write([float1], {
+                    'float': 0,
+                    })
+            self.assertEqual(float1.float, 0)
+
+            self.float.write([float2], {
+                    'float': 1.1,
+                    })
+            self.assertEqual(float2.float, 1.1)
+
+            self.assertRaises(Exception, self.float.create, {
+                    'float': 'test',
+                    })
+
+            self.assertRaises(Exception, self.float.write, [float1], {
+                    'float': 'test',
+                    })
 
             self.assertRaises(Exception, self.float_required.create, {})
             transaction.cursor.rollback()
 
-            float5_id = self.float_required.create({
+            float5 = self.float_required.create({
                     'float': 0.0,
                     })
-            float5 = self.float_required.read(float5_id)
-            self.assert_(float5['float'] == 0.0)
-
-            float6_id = self.float_digits.create({
-                'digits': 1,
-                'float': 1.1,
-                })
-            self.assert_(float6_id)
-
-            self.failUnlessRaises(Exception, self.float_digits.create, {
-                'digits': 1,
-                'float': 1.11,
-                })
-
-            self.failUnlessRaises(Exception, self.float_digits.write,
-                float6_id, {
+            self.assertEqual(float5.float, 0.0)
+
+            float6 = self.float_digits.create({
+                    'digits': 1,
+                    'float': 1.1,
+                    })
+            self.assert_(float6)
+
+            self.assertRaises(Exception, self.float_digits.create, {
+                    'digits': 1,
                     'float': 1.11,
                     })
 
-            self.failUnlessRaises(Exception, self.float_digits.write,
-                float6_id, {
+            self.assertRaises(Exception, self.float_digits.write,
+                [float6], {
+                    'float': 1.11,
+                    })
+
+            self.assertRaises(Exception, self.float_digits.write,
+                [float6], {
                     'digits': 0,
                     })
 
-            float7_id = self.float.create({
-                'float': 0.123456789012345,
-                })
-
-            float7 = self.float.read(float7_id, ['float'])
-            self.assert_(float7['float'] == 0.123456789012345)
+            float7 = self.float.create({
+                    'float': 0.123456789012345,
+                    })
+            self.assertEqual(float7.float, 0.123456789012345)
 
             transaction.cursor.rollback()
 
